//+------------------------------------------------------------------+
//|                                                     T3 ALPHA.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 8
//----
#property indicator_color8 Chocolate
#property indicator_color7 Blue
#property indicator_color6 SlateBlue
#property indicator_color5 White
#property indicator_width5 2
#property indicator_color4 LimeGreen
#property indicator_color3 Magenta
#property indicator_color2 Red
#property indicator_color1 Gray
#property indicator_width1 2
//----
extern bool ShowCross = true;
extern int MA_Period_1=2;
extern int MA_Period_2=3;
extern int MA_Period_3=8; //8
extern int MA_Period_4=13; //12
extern int MA_Period_5=21;
extern int MA_Period_6=34;
extern int MA_Period_7=55;
extern int MA_Period_8=89;
extern double b=0.01;
//----
double MapBuffer1[], MapBuffer2[], MapBuffer3[], MapBuffer4[], MapBuffer5[], MapBuffer6[], MapBuffer7[], MapBuffer8[] ;
//----
double e1[][9], e2[][9], e3[][9], e4[][9], e5[][9], e6[][9], e7[][9];
double c1[9], c2[9], c3[9], c4[9];
double n[9], w1[9], w2[9], b2[9], b3[9];
//int key;
//+------------------------------------------------------------------+
int init()  {
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   SetIndexDrawBegin(0, 100);   SetIndexBuffer(0, MapBuffer8);   SetIndexStyle(0, DRAW_LINE);  SetIndexLabel(0, NULL);
   SetIndexDrawBegin(1, 100);   SetIndexBuffer(1, MapBuffer7);   SetIndexStyle(1, DRAW_LINE);  SetIndexLabel(1, NULL);
   SetIndexDrawBegin(2, 100);   SetIndexBuffer(2, MapBuffer6);   SetIndexStyle(2, DRAW_LINE);  SetIndexLabel(2, NULL);
   SetIndexDrawBegin(3, 100);   SetIndexBuffer(3, MapBuffer5);   SetIndexStyle(3, DRAW_LINE);  SetIndexLabel(3, NULL);
   SetIndexDrawBegin(4, 100);   SetIndexBuffer(4, MapBuffer4);   SetIndexStyle(4, DRAW_LINE);  SetIndexLabel(4, "13");
   SetIndexDrawBegin(5, 100);   SetIndexBuffer(5, MapBuffer3);   SetIndexStyle(5, DRAW_LINE);  SetIndexLabel(5, NULL);
   SetIndexDrawBegin(6, 100);   SetIndexBuffer(6, MapBuffer2);   SetIndexStyle(6, DRAW_LINE);  SetIndexLabel(6, NULL); 
   SetIndexDrawBegin(7, 100);   SetIndexBuffer(7, MapBuffer1);   SetIndexStyle(7, DRAW_LINE);  SetIndexLabel(7, NULL);
   IndicatorShortName("T3 ALPHA");
   
//---- variable reset
   n[1]=MA_Period_1;
   n[2]=MA_Period_2;
   n[3]=MA_Period_3;
   n[4]=MA_Period_4;
   n[5]=MA_Period_5;
   n[6]=MA_Period_6;
   n[7]=MA_Period_7;
   n[8]=MA_Period_8;
//----
   for(int l=1; l < 9; l++)     {
      //e2[l]=0; e3[l]=0; e4[l]=0; e5[l]=0; e6[l]=0;
      c1[l]=0; c2[l]=0; c3[l]=0; c4[l]=0;
      w1[l]=0; w2[l]=0;
      b2[l]=0; b3[l]=0;
      //----
      b2[l]=b*b;
      b3[l]=b2[l]*b;
      c1[l]=-b3[l];
      c2[l]=(3*(b2[l] + b3[l]));
      c3[l]=-3*(2*b2[l] + b + b3[l]);
      c4[l] =(1 + 3*b + b3[l] + 3*b2[l]);
      //----
      if(n[l] < 1)   n[l]=1;
      n[l]=1 + 0.5*(n[l] - 1);
      w1[l]=2/(n[l] + 1);
      w2[l]=1 - w1[l];
   }
   return(0);
}
//+------------------------------------------------------------------+
int start()  {
   int limit, ii, i;
   int counted_bars=IndicatorCounted();
   if(counted_bars < 0)      return(-1);
   if(counted_bars > 0)      counted_bars--;
   limit=(Bars - counted_bars) - 1;
//---- indicator calculation
   ArrayResize(e1, Bars + 1);   ArrayResize(e2, Bars + 1);   ArrayResize(e3, Bars + 1);
   ArrayResize(e4, Bars + 1);   ArrayResize(e5, Bars + 1);   ArrayResize(e6, Bars + 1);   ArrayResize(e7, Bars + 1);
//----
   for(i=limit; i>=0; i--)     {
     for(ii=1; ii < 9; ii++)  {
       e1[Bars-i][ii]=w1[ii]*Close[i] + w2[ii]*e1[(Bars-i)-1][ii];
       e2[Bars-i][ii]=w1[ii]*e1[Bars-i][ii] + w2[ii]*e2[(Bars-i)-1][ii];
       e3[Bars-i][ii]=w1[ii]*e2[Bars-i][ii] + w2[ii]*e3[(Bars-i)-1][ii];
       e4[Bars-i][ii]=w1[ii]*e3[Bars-i][ii] + w2[ii]*e4[(Bars-i)-1][ii];
       e5[Bars-i][ii]=w1[ii]*e4[Bars-i][ii] + w2[ii]*e5[(Bars-i)-1][ii];
       e6[Bars-i][ii]=w1[ii]*e5[Bars-i][ii] + w2[ii]*e6[(Bars-i)-1][ii];
       e7[Bars-i][ii]=w1[ii]*e6[Bars-i][ii] + w2[ii]*e7[(Bars-i)-1][ii];
       if(ii==1)   MapBuffer1[i]=c1[ii]*e6[Bars-i][ii] + c2[ii]*e5[Bars-i][ii] + c3[ii]*e4[Bars-i][ii] + c4[ii]*e3[Bars-i][ii];
       if(ii==2)   MapBuffer2[i]=c1[ii]*e6[Bars-i][ii] + c2[ii]*e5[Bars-i][ii] + c3[ii]*e4[Bars-i][ii] + c4[ii]*e3[Bars-i][ii];
       if(ii==3)   MapBuffer3[i]=c1[ii]*e6[Bars-i][ii] + c2[ii]*e5[Bars-i][ii] + c3[ii]*e4[Bars-i][ii] + c4[ii]*e3[Bars-i][ii];
       if(ii==4)   MapBuffer4[i]=c1[ii]*e6[Bars-i][ii] + c2[ii]*e5[Bars-i][ii] + c3[ii]*e4[Bars-i][ii] + c4[ii]*e3[Bars-i][ii];
       if(ii==5)   MapBuffer5[i]=c1[ii]*e6[Bars-i][ii] + c2[ii]*e5[Bars-i][ii] + c3[ii]*e4[Bars-i][ii] + c4[ii]*e3[Bars-i][ii];
       if(ii==6)   MapBuffer6[i]=c1[ii]*e6[Bars-i][ii] + c2[ii]*e5[Bars-i][ii] + c3[ii]*e4[Bars-i][ii] + c4[ii]*e3[Bars-i][ii];
       if(ii==7)   MapBuffer7[i]=c1[ii]*e6[Bars-i][ii] + c2[ii]*e5[Bars-i][ii] + c3[ii]*e4[Bars-i][ii] + c4[ii]*e3[Bars-i][ii];
       if(ii==8)   MapBuffer8[i]=c1[ii]*e6[Bars-i][ii] + c2[ii]*e5[Bars-i][ii] + c3[ii]*e4[Bars-i][ii] + c4[ii]*e3[Bars-i][ii];
     }
   }
  // if(key!=Time[0] && ShowCross)  {
    // if(MapBuffer1[2]>MapBuffer4[2] && MapBuffer1[1]<MapBuffer4[1])  Alert(Symbol(),"   ", Period(),"     1 ");
    // if(MapBuffer1[2]<MapBuffer4[2] && MapBuffer1[1]>MapBuffer4[1])  Alert(Symbol(),"   ", Period(),"     1 ");
    // key=Time[0];
  // }
   return(0);
}
//+------------------------------------------------------------------+

